LibreOffice: salhelper::SimpleReferenceObject Class Reference

LibreOffice LibreOffice 25.8 SDK C/C++ API Reference

Loading...
Searching...
No Matches
salhelper::SimpleReferenceObject Class Reference

A simple base implementation for reference-counted objects. More...

`#include <simplereferenceobject.hxx>`

Inheritance diagram for salhelper::SimpleReferenceObject:

## Public Member Functions
| SimpleReferenceObject ()
void | acquire ()
void | release ()

## Static Public Member Functions
static void * | operator new (std::size_t nSize)
| see general class documentation
static void * | operator new (std::size_t nSize, std::nothrow_t const &rNothrow)
| see general class documentation
static void | operator delete (void *pPtr)
| see general class documentation
static void | operator delete (void *pPtr, std::nothrow_t const &rNothrow)
| see general class documentation

## Protected Member Functions
virtual | ~SimpleReferenceObject () COVERITY_NOEXCEPT_FALSE
void | staticize ()
| mark reference count as not to be touched, and the related object as having an indefinite lifespan.

## Protected Attributes
oslInterlockedCount | m_nCount

## Detailed Description

A simple base implementation for reference-counted objects.

Classes that want to implement a reference-counting mechanism based on the acquire()/release() interface should derive from this class.

The reason to have class local operators new and delete here is technical. Imagine a class D derived from SimpleReferenceObject, but implemented in another shared library that happens to use different global operators new and delete from those used in this shared library (which, sadly, seems to be possible with shared libraries). Now, without the class local operators new and delete here, a code sequence like "new D" would use the global operator new as found in the other shared library, while the code sequence "delete this" in release() would use the global operator delete as found in this shared library—and these two operators would not be guaranteed to match.

There are no overloaded operators new and delete for placement new here, because it is felt that the concept of placement new does not work well with the concept of reference-counted objects; so it seems best to simply leave those operators out.

The same problem as with operators new and delete would also be there with operators new[] and delete[]. But since arrays of reference-counted objects are of no use, anyway, it seems best to simply define operators new[] and delete[] as deleted.

## Constructor & Destructor Documentation

## ◆ SimpleReferenceObject()

salhelper::SimpleReferenceObject::SimpleReferenceObject | ( |  | ) |
| inline

## ◆ ~SimpleReferenceObject()

virtual salhelper::SimpleReferenceObject::~SimpleReferenceObject | ( |  | ) |
| protectedvirtual

## Member Function Documentation

## ◆ acquire()

void salhelper::SimpleReferenceObject::acquire | ( |  | ) |
| inline

Attention
  If, for any individual instance of SimpleReferenceObject, the total number of calls to acquire() exceeds the total number of calls to release() by 2^31 - the object will never subsequently be released.

## ◆ operator delete() [1/2]

void salhelper::SimpleReferenceObject::operator delete | ( | void * | pPtr | ) |
| static

see general class documentation

## ◆ operator delete() [2/2]

void salhelper::SimpleReferenceObject::operator delete | ( | void * | pPtr,
|  | std::nothrow_t const & | rNothrow )
| static

see general class documentation

## ◆ operator new() [1/2]

void * salhelper::SimpleReferenceObject::operator new | ( | std::size_t | nSize | ) |
| static

see general class documentation

## ◆ operator new() [2/2]

void * salhelper::SimpleReferenceObject::operator new | ( | std::size_t | nSize,
|  | std::nothrow_t const & | rNothrow )
| static

see general class documentation

## ◆ release()

void salhelper::SimpleReferenceObject::release | ( |  | ) |
| inline

## ◆ staticize()

void salhelper::SimpleReferenceObject::staticize | ( |  | ) |
| inlineprotected

mark reference count as not to be touched, and the related object as having an indefinite lifespan.

NB. do not use if you have a non-empty destructor.

## Member Data Documentation

## ◆ m_nCount

oslInterlockedCount salhelper::SimpleReferenceObject::m_nCount
| protected

The documentation for this class was generated from the following file:

- salhelper/simplereferenceobject.hxx